function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import * as React from "react";
import { Image } from "react-native";

/**
 * This import is used by the Svelte SDK. Do not remove.
 */

import { isEditing } from "../../functions/is-editing";
import { getSrcSet } from "../image/image.helpers";
function ImgComponent(props) {
  function srcSetToUse() {
    const url = props.imgSrc || props.image;
    if (!url || typeof url !== "string") {
      return undefined;
    }

    // We can auto add srcset for cdn.builder.io images
    if (!url.match(/builder\.io/)) {
      return undefined;
    }
    return getSrcSet(url);
  }
  return /*#__PURE__*/React.createElement(Image, _extends({
    loading: "lazy",
    style: {
      objectFit: props.backgroundSize || "cover",
      objectPosition: props.backgroundPosition || "center"
    },
    key: isEditing() && props.imgSrc || "default-key",
    alt: props.altText,
    source: {
      uri: props.imgSrc || props.image
    },
    srcSet: srcSetToUse()
  }, props.attributes));
}
export default ImgComponent;
//# sourceMappingURL=img.js.map