import * as React from "react";
import { FlatList } from "react-native";
import { useContext } from "react";
import BuilderContext from "../../context/builder.context";
import ComponentsContext from "../../context/components.context";
import Block from "../block/block";
import BlocksWrapper from "./blocks-wrapper";
import { memo } from "react";
function Blocks(props) {
  var _props$context, _props$context2;
  const builderContext = useContext(BuilderContext);
  const componentsContext = useContext(ComponentsContext);
  const renderItem = React.useCallback(({
    item
  }) => /*#__PURE__*/React.createElement(Block, {
    block: item,
    linkComponent: props.linkComponent,
    context: props.context || builderContext,
    registeredComponents: props.registeredComponents || (componentsContext === null || componentsContext === void 0 ? void 0 : componentsContext.registeredComponents)
  }), [props.linkComponent, props.context, props.registeredComponents, builderContext, componentsContext === null || componentsContext === void 0 ? void 0 : componentsContext.registeredComponents]);

  // Memoize keyExtractor
  const keyExtractor = React.useCallback(item => item.id.toString(), []);
  return /*#__PURE__*/React.createElement(BlocksWrapper, {
    blocks: props.blocks,
    parent: props.parent,
    path: props.path,
    styleProp: props.styleProp,
    BlocksWrapperProps: props.BlocksWrapperProps || ((_props$context = props.context) === null || _props$context === void 0 ? void 0 : _props$context.BlocksWrapperProps) || (builderContext === null || builderContext === void 0 ? void 0 : builderContext.BlocksWrapperProps),
    classNameProp: props.className,
    BlocksWrapper: ((_props$context2 = props.context) === null || _props$context2 === void 0 ? void 0 : _props$context2.BlocksWrapper) || (builderContext === null || builderContext === void 0 ? void 0 : builderContext.BlocksWrapper)
  }, props.children, props.blocks ? /*#__PURE__*/React.createElement(FlatList, {
    data: props.blocks,
    renderItem: renderItem,
    keyExtractor: keyExtractor,
    removeClippedSubviews: true,
    maxToRenderPerBatch: 10,
    windowSize: 5,
    initialNumToRender: 5
  }) : null);
}
export default /*#__PURE__*/memo(Blocks);
//# sourceMappingURL=blocks.js.map