import type { BuilderContextInterface, RegisteredComponent, RegisteredComponents } from '../../context/types';
import type { BuilderBlock } from '../../types/builder-block';
import type { RepeatData } from './types';
export declare const getComponent: ({ block, registeredComponents, model }: {
    block: BuilderBlock;
    registeredComponents: RegisteredComponents;
    model: string;
}) => RegisteredComponent;
export declare const getRepeatItemData: ({ block, context }: {
    block: BuilderBlock;
    context: BuilderContextInterface;
}) => RepeatData[] | undefined;
export declare const getInheritedStyles: ({ block, context }: {
    block: BuilderBlock;
    context: BuilderContextInterface;
}) => Partial<CSSStyleDeclaration>;
export declare const provideLinkComponent: (block: RegisteredComponent | null | undefined, linkComponent: any) => {
    builderLinkComponent: any;
} | {
    builderLinkComponent?: undefined;
};
export declare const provideRegisteredComponents: (block: RegisteredComponent | null | undefined, registeredComponents: RegisteredComponents, model: string) => {
    builderComponents: {
        [k: string]: RegisteredComponent;
    };
} | {
    builderComponents?: undefined;
};
export declare const provideBuilderBlock: (block: RegisteredComponent | null | undefined, builderBlock: BuilderBlock) => {
    builderBlock: BuilderBlock;
} | {
    builderBlock?: undefined;
};
export declare const provideBuilderContext: (block: RegisteredComponent | null | undefined, context: BuilderContextInterface) => {
    builderContext: BuilderContextInterface;
} | {
    builderContext?: undefined;
};
export declare const generateKey: (index: number) => string;
//# sourceMappingURL=block.helpers.d.ts.map