"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Video;
var React = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeVideo = _interopRequireDefault(require("react-native-video"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
// TO-DO: This file breaks due to this issue:
// https://github.com/expo/web-examples/issues/73
// For now, we do not import it elsewhere to avoid crashing Expo servers on web when importing the SDK.

// Subset of Image props, many are irrelevant for native (such as altText, etc)
/**
 * 
 * @typedef {{
 *   attributes?: any;
 *   video?: string;
 *   autoPlay?: boolean;
 *   controls?: boolean;
 *   muted?: boolean;
 *   loop?: boolean;
 *   playsInline?: boolean;
 *   aspectRatio?: number;
 *   fit?: 'contain' | 'cover' | 'stretch';
 *   position?:
 *     | 'center'
 *     | 'top'
 *     | 'left'
 *     | 'right'
 *     | 'bottom'
 *     | 'top left'
 *     | 'top right'
 *     | 'bottom left'
 *     | 'bottom right';
 *   posterImage?: string;
 *   children?: any;
 * }} VideoProps
 */

// TODO: support children by wrapping in a View

/**
 * @param {VideoProps} props
 */
function Video(props) {
  return /*#__PURE__*/React.createElement(_reactNative.View, {
    style: {
      position: 'relative'
    }
  }, /*#__PURE__*/React.createElement(_reactNativeVideo.default, {
    paused: !props.autoPlay,
    controls: props.controls,
    muted: props.muted,
    repeat: props.loop,
    poster: props.posterImage,
    posterResizeMode: props.fit || 'contain',
    resizeMode: props.fit || 'contain',
    style: {
      position: 'absolute',
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      zIndex: 1
    },
    source: {
      uri: props.video
    }
  }), /*#__PURE__*/React.createElement(_reactNative.View, {
    style: {
      width: '100%',
      paddingTop: `${props.aspectRatio * 100}%`
    }
  }));
}
//# sourceMappingURL=video.js.map