"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getWrapperProps = void 0;
var _getBlockProperties = require("../../../../functions/get-block-properties");
const getWrapperProps = ({
  componentOptions,
  builderBlock,
  context,
  componentRef,
  includeBlockProps,
  isInteractive,
  contextValue
}) => {
  const wrapperPropsWithAttributes = {
    ...componentOptions,
    /**
     * If `noWrap` is set to `true`, then the block's props/attributes are provided to the
     * component itself directly. Otherwise, they are provided to the wrapper element.
     */
    ...(includeBlockProps ? {
      attributes: (0, _getBlockProperties.getBlockProperties)({
        block: builderBlock,
        context: contextValue
      })
    } : {})
  };
  const interactiveElementProps = {
    Wrapper: componentRef,
    block: builderBlock,
    context,
    wrapperProps: componentOptions,
    includeBlockProps
  };
  return isInteractive ? interactiveElementProps : wrapperPropsWithAttributes;
};
exports.getWrapperProps = getWrapperProps;
//# sourceMappingURL=component-ref.helpers.js.map