"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var React = _react;
var _reactNative = require("react-native");
var _builder = _interopRequireDefault(require("../../context/builder.context"));
var _components = _interopRequireDefault(require("../../context/components.context"));
var _block = _interopRequireDefault(require("../block/block"));
var _blocksWrapper = _interopRequireDefault(require("./blocks-wrapper"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function Blocks(props) {
  var _props$context, _props$context2;
  const builderContext = (0, _react.useContext)(_builder.default);
  const componentsContext = (0, _react.useContext)(_components.default);
  const renderItem = React.useCallback(({
    item
  }) => /*#__PURE__*/React.createElement(_block.default, {
    block: item,
    linkComponent: props.linkComponent,
    context: props.context || builderContext,
    registeredComponents: props.registeredComponents || (componentsContext === null || componentsContext === void 0 ? void 0 : componentsContext.registeredComponents)
  }), [props.linkComponent, props.context, props.registeredComponents, builderContext, componentsContext === null || componentsContext === void 0 ? void 0 : componentsContext.registeredComponents]);

  // Memoize keyExtractor
  const keyExtractor = React.useCallback(item => item.id.toString(), []);
  return /*#__PURE__*/React.createElement(_blocksWrapper.default, {
    blocks: props.blocks,
    parent: props.parent,
    path: props.path,
    styleProp: props.styleProp,
    BlocksWrapperProps: props.BlocksWrapperProps || ((_props$context = props.context) === null || _props$context === void 0 ? void 0 : _props$context.BlocksWrapperProps) || (builderContext === null || builderContext === void 0 ? void 0 : builderContext.BlocksWrapperProps),
    classNameProp: props.className,
    BlocksWrapper: ((_props$context2 = props.context) === null || _props$context2 === void 0 ? void 0 : _props$context2.BlocksWrapper) || (builderContext === null || builderContext === void 0 ? void 0 : builderContext.BlocksWrapper)
  }, props.children, props.blocks ? /*#__PURE__*/React.createElement(_reactNative.FlatList, {
    data: props.blocks,
    renderItem: renderItem,
    keyExtractor: keyExtractor,
    removeClippedSubviews: true,
    maxToRenderPerBatch: 10,
    windowSize: 5,
    initialNumToRender: 5
  }) : null);
}
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(Blocks);
//# sourceMappingURL=blocks.js.map