"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBlockProperties = getBlockProperties;
var _getClassPropName = require("./get-class-prop-name");
var _getStyle = require("./get-style");
var _transformBlockProperties = require("./transform-block-properties");
const extractRelevantRootBlockProperties = block => {
  // currently we are only spreading the `href` property
  // TO-DO: potentially spread all properties from block, but only if they are not already defined by BuilderBlock

  // const {
  //   '@type': _type,
  //   '@version': _version,
  //   id: _id,
  //   tagName: _tagName,
  //   layerName: _layerName,
  //   groupLocked: _groupLocked,
  //   layerLocked: _layerLocked,
  //   class: _class,
  //   children: _children,
  //   responsiveStyles: _responsiveStyles,
  //   component: _component,
  //   bindings: _bindings,
  //   meta: _meta,
  //   actions: _actions,
  //   properties: _properties,
  //   code: _code,
  //   repeat: _repeat,
  //   animations: _animations,
  //   style: _style,
  //   hide: _hide,
  //   show: _show,
  //   // anything set by dynamic bindings outside of predefined `BuilderBlock` properties
  //   ...remainingBlockProperties
  // } = block;

  return {
    href: block.href
  };
};
function getBlockProperties({
  block,
  context
}) {
  var _block$properties;
  const properties = {
    ...extractRelevantRootBlockProperties(block),
    ...block.properties,
    'builder-id': block.id,
    style: (0, _getStyle.getStyle)({
      block,
      context
    }),
    [(0, _getClassPropName.getClassPropName)()]: [block.id, 'builder-block', block.class, (_block$properties = block.properties) === null || _block$properties === void 0 ? void 0 : _block$properties.class].filter(Boolean).join(' ')
  };
  return (0, _transformBlockProperties.transformBlockProperties)({
    properties,
    context,
    block
  });
}
//# sourceMappingURL=get-block-properties.js.map