"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetch = void 0;
var _getGlobalThis = require("./get-global-this");
function getFetch() {
  const globalFetch = (0, _getGlobalThis.getGlobalThis)().fetch;
  if (typeof globalFetch === 'undefined') {
    console.warn(`Builder SDK could not find a global fetch function. Make sure you have a polyfill for fetch in your project. 
      For more information, read https://github.com/BuilderIO/this-package-uses-fetch`);
    throw new Error('Builder SDK could not find a global `fetch` function');
  }
  return globalFetch;
}
const fetch = exports.fetch = getFetch();
//# sourceMappingURL=get-fetch.js.map