"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.register = register;
var _isBrowser = require("./is-browser");
var _registerComponent = require("./register-component");
const registry = {};
function register(type, info) {
  if (type === 'plugin') {
    info = (0, _registerComponent.serializeIncludingFunctions)(info);
  }
  let typeList = registry[type];
  if (!typeList) {
    typeList = registry[type] = [];
  }
  typeList.push(info);
  if ((0, _isBrowser.isBrowser)()) {
    const message = {
      type: 'builder.register',
      data: {
        type,
        info
      }
    };
    try {
      parent.postMessage(message, '*');
      if (parent !== window) {
        window.postMessage(message, '*');
      }
    } catch (err) {
      console.debug('Could not postmessage', err);
    }
  }
}
//# sourceMappingURL=register.js.map