"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transformBlockProperties = transformBlockProperties;
var _reactDom = require("react-dom");
var _isEditing = require("./is-editing");
function transformBlockProperties({
  properties
}) {
  if (!(0, _isEditing.isEditing)()) {
    return properties;
  }
  const id = properties['builder-id'];
  if (!id) {
    console.warn('No builder-id found on properties', properties);
  }
  properties.ref = ref => {
    if ((0, _isEditing.isEditing)()) {
      const el = (0, _reactDom.findDOMNode)(ref);
      if (el && !(el instanceof Text)) {
        el.setAttribute('builder-id', id);
        el.classList.add(id);
      }
    }
  };
  return properties;
}
//# sourceMappingURL=transform-block-properties.js.map