function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import * as React from "react";
import BaseText from "../../blocks/BaseText";
import { View, StyleSheet } from "react-native";
import { useState, useRef } from "react";

/**
 * This import is used by the Svelte SDK. Do not remove.
 */

/**
 * This import is used by the Svelte SDK. Do not remove.
 */

import Blocks from "../../../components/blocks/blocks";
import { getEnv } from "../../../functions/get-env";
import { get } from "../../../functions/get";
import { isEditing } from "../../../functions/is-editing";
import { set } from "../../../functions/set";
import { logFetch } from "../../../functions/log-fetch";
function FormComponent(props) {
  const formRef = useRef(null);
  const [formState, setFormState] = useState(() => "unsubmitted");
  const [responseData, setResponseData] = useState(() => null);
  const [formErrorMessage, setFormErrorMessage] = useState(() => "");
  function mergeNewRootState(newData) {
    const combinedState = {
      ...props.builderContext.rootState,
      ...newData
    };
    if (props.builderContext.rootSetState) {
      var _props$builderContext, _props$builderContext2;
      (_props$builderContext = (_props$builderContext2 = props.builderContext).rootSetState) === null || _props$builderContext === void 0 || _props$builderContext.call(_props$builderContext2, combinedState);
    } else {
      props.builderContext.rootState = combinedState;
    }
  }
  function submissionState() {
    return isEditing() && props.previewState || formState;
  }
  function onSubmit(event) {
    const sendWithJsProp = props.sendWithJs || props.sendSubmissionsTo === "email";
    if (props.sendSubmissionsTo === "zapier") {
      event.preventDefault();
    } else if (sendWithJsProp) {
      if (!(props.action || props.sendSubmissionsTo === "email")) {
        event.preventDefault();
        return;
      }
      event.preventDefault();
      const el = event.currentTarget || event.target;
      const headers = props.customHeaders || {};
      let body;
      const formData = new FormData(el);

      // TODO: maybe support null
      const formPairs = Array.from(el.querySelectorAll("input,select,textarea")).filter(el => !!el.name).map(el => {
        let value;
        const key = el.name;
        if (el instanceof HTMLInputElement) {
          if (el.type === "radio") {
            if (el.checked) {
              value = el.name;
              return {
                key,
                value
              };
            }
          } else if (el.type === "checkbox") {
            value = el.checked;
          } else if (el.type === "number" || el.type === "range") {
            const num = el.valueAsNumber;
            if (!isNaN(num)) {
              value = num;
            }
          } else if (el.type === "file") {
            // TODO: one vs multiple files
            value = el.files;
          } else {
            value = el.value;
          }
        } else {
          value = el.value;
        }
        return {
          key,
          value
        };
      });
      let formContentType = props.contentType;
      if (props.sendSubmissionsTo === "email") {
        formContentType = "multipart/form-data";
      }
      Array.from(formPairs).forEach(({
        value
      }) => {
        if (value instanceof File || Array.isArray(value) && value[0] instanceof File || value instanceof FileList) {
          formContentType = "multipart/form-data";
        }
      });

      // TODO: send as urlEncoded or multipart by default
      // because of ease of use and reliability in browser API
      // for encoding the form?
      if (formContentType !== "application/json") {
        body = formData;
      } else {
        // Json
        const json = {};
        Array.from(formPairs).forEach(({
          value,
          key
        }) => {
          set(json, key, value);
        });
        body = JSON.stringify(json);
      }
      if (formContentType && formContentType !== "multipart/form-data") {
        var _props$action;
        if ( /* Zapier doesn't allow content-type header to be sent from browsers */!(sendWithJsProp && (_props$action = props.action) !== null && _props$action !== void 0 && _props$action.includes("zapier.com"))) {
          headers["content-type"] = formContentType;
        }
      }
      const presubmitEvent = new CustomEvent("presubmit", {
        detail: {
          body
        }
      });
      if (formRef.current) {
        formRef.current.dispatchEvent(presubmitEvent);
        if (presubmitEvent.defaultPrevented) {
          return;
        }
      }
      setFormState("sending");
      if (props.sendSubmissionsTo === "email" && (props.sendSubmissionsToEmail === "your@email.com" || !props.sendSubmissionsToEmail)) {
        const message = "SubmissionsToEmail is required when sendSubmissionsTo is set to email";
        console.error(message);
        setFormState("error");
        mergeNewRootState({
          formErrorMessage: message
        });
        return;
      }
      const formUrl = `${getEnv() === "dev" ? "http://localhost:5000" : "https://builder.io"}/api/v1/form-submit?apiKey=${props.builderContext.apiKey}&to=${btoa(props.sendSubmissionsToEmail || "")}&name=${encodeURIComponent(props.name || "")}`;
      const url = props.sendSubmissionsTo === "email" ? formUrl : props.action;
      /* TODO: throw error if no action URL */
      logFetch(url);
      fetch(url, {
        body,
        headers,
        method: props.method || "post"
      }).then(async res => {
        let body;
        const contentType = res.headers.get("content-type");
        if (contentType && contentType.indexOf("application/json") !== -1) {
          body = await res.json();
        } else {
          body = await res.text();
        }
        if (!res.ok) {
          var _formRef$current;
          const submitErrorEvent = new CustomEvent("submit:error", {
            detail: {
              error: body,
              status: res.status
            }
          });
          if ((_formRef$current = formRef.current) !== null && _formRef$current !== void 0 && _formRef$current.nativeElement) {
            var _formRef$current2;
            (_formRef$current2 = formRef.current) === null || _formRef$current2 === void 0 || _formRef$current2.nativeElement.dispatchEvent(submitErrorEvent);
            if (submitErrorEvent.defaultPrevented) {
              return;
            }
          }
          setResponseData(body);
          setFormState("error");
          let message = props.errorMessagePath ? get(body, props.errorMessagePath) : body.message || body.error || body;
          if (typeof message !== "string") {
            message = JSON.stringify(message);
          }
          setFormErrorMessage(message);
          mergeNewRootState({
            formErrorMessage: message
          });
          return;
        }
        setResponseData(body);
        setFormState(res.ok ? "success" : "error");
        if (res.ok) {
          const submitSuccessEvent = new CustomEvent("submit:success", {
            detail: {
              res,
              body
            }
          });
          if (formRef.current) {
            formRef.current.dispatchEvent(submitSuccessEvent);
            if (submitSuccessEvent.defaultPrevented) {
              return;
            }
            /* TODO: option to turn this on/off? */
            if (props.resetFormOnSubmit !== false) {
              formRef.current.reset();
            }
          }
          /* TODO: client side route event first that can be preventDefaulted */
          if (props.successUrl) {
            if (formRef.current) {
              const event = new CustomEvent("route", {
                detail: {
                  url: props.successUrl
                }
              });
              formRef.current.dispatchEvent(event);
              if (!event.defaultPrevented) {
                location.href = props.successUrl;
              }
            } else {
              location.href = props.successUrl;
            }
          }
        }
      }, err => {
        const submitErrorEvent = new CustomEvent("submit:error", {
          detail: {
            error: err
          }
        });
        if (formRef.current) {
          formRef.current.dispatchEvent(submitErrorEvent);
          if (submitErrorEvent.defaultPrevented) {
            return;
          }
        }
        setResponseData(err);
        setFormState("error");
      });
    }
  }
  return /*#__PURE__*/React.createElement(View, _extends({
    validate: props.validate,
    ref: formRef,
    action: !props.sendWithJs && props.action,
    method: props.method,
    name: props.name,
    onSubmit: event => onSubmit(event)
  }, props.attributes), props.children, submissionState() === "error" ? /*#__PURE__*/React.createElement(Blocks, {
    path: "errorMessage",
    blocks: props.errorMessage,
    context: props.builderContext
  }) : null, submissionState() === "sending" ? /*#__PURE__*/React.createElement(Blocks, {
    path: "sendingMessage",
    blocks: props.sendingMessage,
    context: props.builderContext
  }) : null, submissionState() === "error" && responseData ? /*#__PURE__*/React.createElement(View, {
    style: styles.view1
  }, /*#__PURE__*/React.createElement(BaseText, null, JSON.stringify(responseData, null, 2))) : null, submissionState() === "success" ? /*#__PURE__*/React.createElement(Blocks, {
    path: "successMessage",
    blocks: props.successMessage,
    context: props.builderContext
  }) : null);
}
const styles = StyleSheet.create({
  view1: {
    padding: 10,
    color: "red",
    textAlign: "center"
  }
});
export default FormComponent;
//# sourceMappingURL=form.js.map