import * as React from "react";
import { useState, useEffect } from "react";
import { SDKS_SUPPORTING_PERSONALIZATION, getInitPersonalizationVariantsFnsScriptString } from "../../blocks/personalization-container/helpers";
import { TARGET } from "../../constants/target";
import { handleABTestingSync } from "../../helpers/ab-tests";
import { getDefaultCanTrack } from "../../helpers/canTrack";
import ContentComponent from "../content/content";
import InlinedScript from "../inlined-script";
import InlinedStyles from "../inlined-styles";
import { checkShouldRenderVariants, getInitVariantsFnsScriptString, getUpdateCookieAndStylesScript, getVariants } from "./helpers";
function ContentVariants(props) {
  var _getVariants;
  const [shouldRenderVariants, setShouldRenderVariants] = useState(() => checkShouldRenderVariants({
    canTrack: getDefaultCanTrack(props.canTrack),
    content: props.content
  }));
  function updateCookieAndStylesScriptStr() {
    var _props$content;
    return getUpdateCookieAndStylesScript(getVariants(props.content).map(value => ({
      id: value.testVariationId,
      testRatio: value.testRatio
    })), ((_props$content = props.content) === null || _props$content === void 0 ? void 0 : _props$content.id) || "");
  }
  function hideVariantsStyleString() {
    return getVariants(props.content).map(value => `.variant-${value.testVariationId} { display: none; } `).join("");
  }
  function defaultContent() {
    var _props$content2;
    return shouldRenderVariants ? {
      ...props.content,
      testVariationId: (_props$content2 = props.content) === null || _props$content2 === void 0 ? void 0 : _props$content2.id
    } : handleABTestingSync({
      item: props.content,
      canTrack: getDefaultCanTrack(props.canTrack)
    });
  }
  useEffect(() => {
    /**
     * For Solid/Svelte: we unmount the non-winning variants post-hydration.
     */
  }, []);
  return /*#__PURE__*/React.createElement(React.Fragment, null, !props.isNestedRender && TARGET !== "reactNative" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(InlinedScript, {
    id: "builderio-init-variants-fns",
    scriptStr: getInitVariantsFnsScriptString(),
    nonce: props.nonce || ""
  }), SDKS_SUPPORTING_PERSONALIZATION.includes(TARGET) ? /*#__PURE__*/React.createElement(InlinedScript, {
    id: "builderio-init-personalization-variants-fns",
    nonce: props.nonce || "",
    scriptStr: getInitPersonalizationVariantsFnsScriptString()
  }) : null) : null, shouldRenderVariants ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(InlinedStyles, {
    id: "builderio-variants",
    styles: hideVariantsStyleString(),
    nonce: props.nonce || ""
  }), /*#__PURE__*/React.createElement(InlinedScript, {
    id: "builderio-variants-visibility",
    scriptStr: updateCookieAndStylesScriptStr(),
    nonce: props.nonce || ""
  }), (_getVariants = getVariants(props.content)) === null || _getVariants === void 0 ? void 0 : _getVariants.map(variant => /*#__PURE__*/React.createElement(ContentComponent, {
    apiHost: props.apiHost,
    isNestedRender: props.isNestedRender,
    key: variant.testVariationId,
    nonce: props.nonce,
    content: variant,
    showContent: false,
    model: props.model,
    data: props.data,
    context: props.context,
    apiKey: props.apiKey,
    apiVersion: props.apiVersion,
    customComponents: props.customComponents,
    linkComponent: props.linkComponent,
    canTrack: props.canTrack,
    locale: props.locale,
    enrich: props.enrich,
    isSsrAbTest: shouldRenderVariants,
    blocksWrapper: props.blocksWrapper,
    blocksWrapperProps: props.blocksWrapperProps,
    contentWrapper: props.contentWrapper,
    contentWrapperProps: props.contentWrapperProps,
    trustedHosts: props.trustedHosts,
    strictStyleMode: props.strictStyleMode
  }))) : null, /*#__PURE__*/React.createElement(ContentComponent, {
    apiHost: props.apiHost,
    nonce: props.nonce,
    isNestedRender: props.isNestedRender,
    strictStyleMode: props.strictStyleMode,
    content: defaultContent(),
    showContent: true,
    model: props.model,
    data: props.data,
    context: props.context,
    apiKey: props.apiKey,
    apiVersion: props.apiVersion,
    customComponents: props.customComponents,
    linkComponent: props.linkComponent,
    canTrack: props.canTrack,
    locale: props.locale,
    enrich: props.enrich,
    isSsrAbTest: shouldRenderVariants,
    blocksWrapper: props.blocksWrapper,
    blocksWrapperProps: props.blocksWrapperProps,
    contentWrapper: props.contentWrapper,
    contentWrapperProps: props.contentWrapperProps,
    trustedHosts: props.trustedHosts
  }));
}
export default ContentVariants;
//# sourceMappingURL=content-variants.js.map