"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchSymbolContent = void 0;
var _index = require("../../functions/get-content/index");
var _logger = require("../../helpers/logger");
const fetchSymbolContent = async ({
  builderContextValue,
  symbol
}) => {
  /**
   * If:
   * - we have a symbol prop
   * - yet it does not have any content
   * - and we have not already stored content from before
   * - and it has a model name
   *
   * then we want to re-fetch the symbol content.
   */
  if (symbol !== null && symbol !== void 0 && symbol.model && // This is a hack, we should not need to check for this, but it is needed for Svelte.
  builderContextValue !== null && builderContextValue !== void 0 && builderContextValue.apiKey) {
    return (0, _index.fetchOneEntry)({
      model: symbol.model,
      apiKey: builderContextValue.apiKey,
      apiVersion: builderContextValue.apiVersion,
      ...((symbol === null || symbol === void 0 ? void 0 : symbol.entry) && {
        query: {
          id: symbol.entry
        }
      })
    }).catch(err => {
      _logger.logger.error('Could not fetch symbol content: ', err);
      return undefined;
    });
  }
  return undefined;
};
exports.fetchSymbolContent = fetchSymbolContent;
//# sourceMappingURL=symbol.helpers.js.map