"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isPreviewing = isPreviewing;
var _search2 = require("../helpers/search/search");
var _isBrowser = require("./is-browser");
function isPreviewing(_search) {
  const search = _search || ((0, _isBrowser.isBrowser)() ? window.location.search : undefined);

  /**
   * If this function is called on the server without an explicit `search` argument,
   * then it can't check if the user is previewing, and will return `false`.
   */
  if (!search) {
    return false;
  }
  const normalizedSearch = (0, _search2.getSearchString)(search);
  return Boolean(normalizedSearch.indexOf('builder.preview=') !== -1);
}
//# sourceMappingURL=is-previewing.js.map