import { isBrowser } from "../functions/is-browser";
const getLocalStorage = () => isBrowser() && typeof localStorage !== 'undefined' ? localStorage : undefined;
export const getLocalStorageItem = ({
  key,
  canTrack
}) => {
  try {
    if (canTrack) {
      var _getLocalStorage;
      return (_getLocalStorage = getLocalStorage()) === null || _getLocalStorage === void 0 ? void 0 : _getLocalStorage.getItem(key);
    }
    return undefined;
  } catch (err) {
    console.debug('[LocalStorage] GET error: ', err);
    return undefined;
  }
};
export const setLocalStorageItem = ({
  key,
  canTrack,
  value
}) => {
  try {
    if (canTrack) {
      var _getLocalStorage2;
      (_getLocalStorage2 = getLocalStorage()) === null || _getLocalStorage2 === void 0 || _getLocalStorage2.setItem(key, value);
    }
  } catch (err) {
    console.debug('[LocalStorage] SET error: ', err);
  }
};
//# sourceMappingURL=localStorage.js.map