import { SDK_VERSION } from "../constants/sdk-version";
import { TARGET } from "../constants/target";
import { isBrowser } from "../functions/is-browser";
import { isFromTrustedHost } from "../functions/is-from-trusted-host";
let isSetupForEditing = false;
export const setupBrowserForEditing = options => {
  if (isSetupForEditing) {
    return;
  }
  isSetupForEditing = true;
  if (isBrowser()) {
    var _window$parent, _window$parent2;
    (_window$parent = window.parent) === null || _window$parent === void 0 || _window$parent.postMessage({
      type: 'builder.sdkInfo',
      data: {
        target: TARGET,
        version: SDK_VERSION,
        supportsPatchUpdates: false,
        // Supports builder-model="..." attribute which is needed to
        // scope our '+ add block' button styling
        supportsAddBlockScoping: true,
        supportsCustomBreakpoints: true,
        modelName: options.modelName,
        apiKey: options.apiKey,
        supportsXSmallBreakpoint: TARGET === 'reactNative' ? false : true,
        blockLevelPersonalization: true
      }
    }, '*');
    (_window$parent2 = window.parent) === null || _window$parent2 === void 0 || _window$parent2.postMessage({
      type: 'builder.updateContent',
      data: {
        options
      }
    }, '*');
    window.addEventListener('message', event => {
      if (!isFromTrustedHost(options.trustedHosts, event)) {
        return;
      }
      const {
        data
      } = event;
      if (!(data !== null && data !== void 0 && data.type)) {
        return;
      }
      switch (data.type) {
        case 'builder.evaluate':
          {
            const text = data.data.text;
            const args = data.data.arguments || [];
            const id = data.data.id;
            // tslint:disable-next-line:no-function-constructor-with-string-args
            const fn = new Function(text);
            let result;
            let error = null;
            try {
              // eslint-disable-next-line prefer-spread
              result = fn.apply(null, args);
            } catch (err) {
              error = err;
            }
            if (error) {
              var _window$parent3;
              (_window$parent3 = window.parent) === null || _window$parent3 === void 0 || _window$parent3.postMessage({
                type: 'builder.evaluateError',
                data: {
                  id,
                  error: error.message
                }
              }, '*');
            } else {
              if (result && typeof result.then === 'function') {
                result.then(finalResult => {
                  var _window$parent4;
                  (_window$parent4 = window.parent) === null || _window$parent4 === void 0 || _window$parent4.postMessage({
                    type: 'builder.evaluateResult',
                    data: {
                      id,
                      result: finalResult
                    }
                  }, '*');
                }).catch(console.error);
              } else {
                var _window$parent5;
                (_window$parent5 = window.parent) === null || _window$parent5 === void 0 || _window$parent5.postMessage({
                  type: 'builder.evaluateResult',
                  data: {
                    result,
                    id
                  }
                }, '*');
              }
            }
            break;
          }
      }
    });
  }
};
//# sourceMappingURL=init-editing.js.map