import type { BuilderContextInterface, RegisteredComponents } from '../../../../context/types';
import type { BuilderBlock } from '../../../../types/builder-block';
import type { BuilderDataProps } from '../../../../types/builder-props';
import type { InteractiveElementProps } from '../interactive-element';
type ComponentOptions = BuilderDataProps & {
    [index: string]: any;
    attributes?: {
        [index: string]: any;
    };
};
export interface ComponentProps {
    componentRef: any;
    componentOptions: ComponentOptions;
    blockChildren: BuilderBlock[];
    context: BuilderContextInterface;
    registeredComponents: RegisteredComponents;
    linkComponent: any;
    builderBlock: BuilderBlock;
    includeBlockProps: boolean;
    isInteractive: boolean | undefined;
}
export declare const getWrapperProps: ({ componentOptions, builderBlock, context, componentRef, includeBlockProps, isInteractive, contextValue }: Omit<ComponentProps, "registeredComponents" | "blockChildren"> & {
    contextValue: BuilderContextInterface;
}) => InteractiveElementProps | {
    attributes?: any;
    builderBlock: BuilderBlock;
    builderContext: BuilderContextInterface;
};
export {};
//# sourceMappingURL=component-ref.helpers.d.ts.map